Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeAnalyzer.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeAnalyzer.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeAnalyzer.cs	(revision 16892)
@@ -0,0 +1,266 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  public static class RegressionTreeAnalyzer {
+    private const string ConditionResultName = "Condition";
+    private const string CoverResultName = "Covered Instances";
+    private const string CoverageDiagramResultName = "Coverage";
+    private const string RuleModelResultName = "RuleModel";
+
+    public static Dictionary<string, int> GetRuleVariableFrequences(RegressionRuleSetModel ruleSetModel) {
+      var res = ruleSetModel.VariablesUsedForPrediction.ToDictionary(x => x, x => 0);
+      foreach (var rule in ruleSetModel.Rules)
+      foreach (var att in rule.SplitAttributes)
+        res[att]++;
+      return res;
+    }
+
+    public static Dictionary<string, int> GetTreeVariableFrequences(RegressionNodeTreeModel treeModel) {
+      var res = treeModel.VariablesUsedForPrediction.ToDictionary(x => x, x => 0);
+      var root = treeModel.Root;
+      foreach (var cur in root.EnumerateNodes().Where(x => !x.IsLeaf))
+        res[cur.SplitAttribute]++;
+      return res;
+    }
+
+    public static Result CreateLeafDepthHistogram(RegressionNodeTreeModel treeModel) {
+      var list = new List<int>();
+      GetLeafDepths(treeModel.Root, 0, list);
+      var row = new DataRow("Depths", "", list.Select(x => (double)x)) {
+        VisualProperties = {ChartType = DataRowVisualProperties.DataRowChartType.Histogram}
+      };
+      var hist = new DataTable("LeafDepths");
+      hist.Rows.Add(row);
+      return new Result(hist.Name, hist);
+    }
+
+    public static Result CreateRulesResult(RegressionRuleSetModel ruleSetModel, IRegressionProblemData pd, string resultName, bool displayModels) {
+      var res = new ResultCollection();
+      var i = 0;
+      foreach (var rule in ruleSetModel.Rules)
+        res.Add(new Result("Rule" + i++, CreateRulesResult(rule, pd, displayModels, out pd)));
+      return new Result(resultName, res);
+    }
+
+    public static IResult CreateCoverageDiagram(RegressionRuleSetModel setModel, IRegressionProblemData problemData) {
+      var res = new DataTable(CoverageDiagramResultName);
+      var training = CountCoverage(setModel, problemData.Dataset, problemData.TrainingIndices);
+      var test = CountCoverage(setModel, problemData.Dataset, problemData.TestIndices);
+      res.Rows.Add(new DataRow("Training", "", training));
+      res.Rows.Add(new DataRow("Test", "", test));
+
+      foreach (var row in res.Rows)
+        row.VisualProperties.ChartType = DataRowVisualProperties.DataRowChartType.Columns;
+      res.VisualProperties.XAxisMaximumFixedValue = training.Count + 1;
+      res.VisualProperties.XAxisMaximumAuto = false;
+      res.VisualProperties.XAxisMinimumFixedValue = 0;
+      res.VisualProperties.XAxisMinimumAuto = false;
+      res.VisualProperties.XAxisTitle = "Rule";
+      res.VisualProperties.YAxisTitle = "Covered Instances";
+
+      return new Result(CoverageDiagramResultName, res);
+    }
+
+    private static void GetLeafDepths(RegressionNodeModel n, int depth, ICollection<int> res) {
+      if (n == null) return;
+      if (n.Left == null && n.Right == null) res.Add(depth);
+      else {
+        GetLeafDepths(n.Left, depth + 1, res);
+        GetLeafDepths(n.Right, depth + 1, res);
+      }
+    }
+
+    private static IScope CreateRulesResult(RegressionRuleModel regressionRuleModel, IRegressionProblemData pd, bool displayModels, out IRegressionProblemData notCovered) {
+      var training = pd.TrainingIndices.Where(x => !regressionRuleModel.Covers(pd.Dataset, x)).ToArray();
+      var test = pd.TestIndices.Where(x => !regressionRuleModel.Covers(pd.Dataset, x)).ToArray();
+      if (training.Length > 0 || test.Length > 0) {
+        var data = new Dataset(pd.Dataset.DoubleVariables, pd.Dataset.DoubleVariables.Select(v => pd.Dataset.GetDoubleValues(v, training.Concat(test)).ToArray()));
+        notCovered = new RegressionProblemData(data, pd.AllowedInputVariables, pd.TargetVariable);
+        notCovered.TestPartition.Start = notCovered.TrainingPartition.End = training.Length;
+        notCovered.TestPartition.End = training.Length + test.Length;
+      } else notCovered = null;
+
+      var training2 = pd.TrainingIndices.Where(x => regressionRuleModel.Covers(pd.Dataset, x)).ToArray();
+      var test2 = pd.TestIndices.Where(x => regressionRuleModel.Covers(pd.Dataset, x)).ToArray();
+      var data2 = new Dataset(pd.Dataset.DoubleVariables, pd.Dataset.DoubleVariables.Select(v => pd.Dataset.GetDoubleValues(v, training2.Concat(test2)).ToArray()));
+      var covered = new RegressionProblemData(data2, pd.AllowedInputVariables, pd.TargetVariable);
+      covered.TestPartition.Start = covered.TrainingPartition.End = training2.Length;
+      covered.TestPartition.End = training2.Length + test2.Length;
+
+      var res2 = new Scope("RuleModels");
+      res2.Variables.Add(new Variable(ConditionResultName, new StringValue(regressionRuleModel.ToCompactString())));
+      res2.Variables.Add(new Variable(CoverResultName, new IntValue(pd.TrainingIndices.Count() - training.Length)));
+      if (displayModels)
+        res2.Variables.Add(new Variable(RuleModelResultName, regressionRuleModel.CreateRegressionSolution(covered)));
+      return res2;
+    }
+
+    private static IReadOnlyList<double> CountCoverage(RegressionRuleSetModel setModel, IDataset data, IEnumerable<int> rows) {
+      var rules = setModel.Rules.ToArray();
+      var res = new double[rules.Length];
+      foreach (var row in rows)
+        for (var i = 0; i < rules.Length; i++)
+          if (rules[i].Covers(data, row)) {
+            res[i]++;
+            break;
+          }
+      return res;
+    }
+
+    public static void AnalyzeNodes(RegressionNodeTreeModel tree, ResultCollection results, IRegressionProblemData pd) {
+      var dict = new Dictionary<int, RegressionNodeModel>();
+      var trainingLeafRows = new Dictionary<int, IReadOnlyList<int>>();
+      var testLeafRows = new Dictionary<int, IReadOnlyList<int>>();
+      var modelNumber = new IntValue(1);
+      var symtree = new SymbolicExpressionTree(MirrorTree(tree.Root, dict, trainingLeafRows, testLeafRows, modelNumber, pd.Dataset, pd.TrainingIndices.ToList(), pd.TestIndices.ToList()));
+      results.AddOrUpdateResult("DecisionTree", symtree);
+
+      if (dict.Count > 200) return;
+      var models = new Scope("NodeModels");
+      results.AddOrUpdateResult("NodeModels", models);
+      foreach (var m in dict.Keys.OrderBy(x => x))
+        models.Variables.Add(new Variable("Model " + m, dict[m].CreateRegressionSolution(Subselect(pd, trainingLeafRows[m], testLeafRows[m]))));
+    }
+
+    public static void PruningChart(RegressionNodeTreeModel tree, ComplexityPruning pruning, ResultCollection results) {
+      var nodes = new Queue<RegressionNodeModel>();
+      nodes.Enqueue(tree.Root);
+      var max = 0.0;
+      var strenghts = new SortedList<double, int>();
+      while (nodes.Count > 0) {
+        var n = nodes.Dequeue();
+
+        if (n.IsLeaf) {
+          max++;
+          continue;
+        }
+
+        if (!strenghts.ContainsKey(n.PruningStrength)) strenghts.Add(n.PruningStrength, 0);
+        strenghts[n.PruningStrength]++;
+        nodes.Enqueue(n.Left);
+        nodes.Enqueue(n.Right);
+      }
+      if (strenghts.Count == 0) return;
+
+      var plot = new ScatterPlot("Pruned Sizes", "") {
+        VisualProperties = {
+          XAxisTitle = "Pruning Strength",
+          YAxisTitle = "Tree Size",
+          XAxisMinimumAuto = false,
+          XAxisMinimumFixedValue = 0
+        }
+      };
+      var row = new ScatterPlotDataRow("TreeSizes", "", new List<Point2D<double>>());
+      row.Points.Add(new Point2D<double>(pruning.PruningStrength, max));
+
+      var fillerDots = new Queue<double>();
+      var minX = pruning.PruningStrength;
+      var maxX = strenghts.Last().Key;
+      var size = (maxX - minX) / 200;
+      for (var x = minX; x <= maxX; x += size) {
+        fillerDots.Enqueue(x);
+      }
+
+      foreach (var strenght in strenghts.Keys) {
+        while (fillerDots.Count > 0 && strenght > fillerDots.Peek())
+          row.Points.Add(new Point2D<double>(fillerDots.Dequeue(), max));
+        max -= strenghts[strenght];
+        row.Points.Add(new Point2D<double>(strenght, max));
+      }
+
+
+      row.VisualProperties.PointSize = 6;
+      plot.Rows.Add(row);
+      results.AddOrUpdateResult("PruningSizes", plot);
+    }
+
+
+    private static IRegressionProblemData Subselect(IRegressionProblemData data, IReadOnlyList<int> training, IReadOnlyList<int> test) {
+      var dataset = RegressionTreeUtilities.ReduceDataset(data.Dataset, training.Concat(test).ToList(), data.AllowedInputVariables.ToList(), data.TargetVariable);
+      var res = new RegressionProblemData(dataset, data.AllowedInputVariables, data.TargetVariable);
+      res.TrainingPartition.Start = 0;
+      res.TrainingPartition.End = training.Count;
+      res.TestPartition.Start = training.Count;
+      res.TestPartition.End = training.Count + test.Count;
+      return res;
+    }
+
+    private static SymbolicExpressionTreeNode MirrorTree(RegressionNodeModel regressionNode, IDictionary<int, RegressionNodeModel> dict,
+      IDictionary<int, IReadOnlyList<int>> trainingLeafRows,
+      IDictionary<int, IReadOnlyList<int>> testLeafRows,
+      IntValue nextId, IDataset data, IReadOnlyList<int> trainingRows, IReadOnlyList<int> testRows) {
+      if (regressionNode.IsLeaf) {
+        var i = nextId.Value++;
+        dict.Add(i, regressionNode);
+        trainingLeafRows.Add(i, trainingRows);
+        testLeafRows.Add(i, testRows);
+        return new SymbolicExpressionTreeNode(new TextSymbol("Model " + i + "\n(" + trainingRows.Count + "/" + testRows.Count + ")"));
+      }
+
+      var pftext = "\npf = " + regressionNode.PruningStrength.ToString("0.###");
+      var text = regressionNode.SplitAttribute + " <= " + regressionNode.SplitValue.ToString("0.###");
+      if (!double.IsNaN(regressionNode.PruningStrength)) text += pftext;
+
+      var textNode = new SymbolicExpressionTreeNode(new TextSymbol(text));
+      IReadOnlyList<int> lTrainingRows, rTrainingRows;
+      IReadOnlyList<int> lTestRows, rTestRows;
+      RegressionTreeUtilities.SplitRows(trainingRows, data, regressionNode.SplitAttribute, regressionNode.SplitValue, out lTrainingRows, out rTrainingRows);
+      RegressionTreeUtilities.SplitRows(testRows, data, regressionNode.SplitAttribute, regressionNode.SplitValue, out lTestRows, out rTestRows);
+
+      textNode.AddSubtree(MirrorTree(regressionNode.Left, dict, trainingLeafRows, testLeafRows, nextId, data, lTrainingRows, lTestRows));
+      textNode.AddSubtree(MirrorTree(regressionNode.Right, dict, trainingLeafRows, testLeafRows, nextId, data, rTrainingRows, rTestRows));
+
+      return textNode;
+    }
+
+
+    [StorableType("D5540C63-310B-4D6F-8A3D-6C1A08DE7F80")]
+    private sealed class TextSymbol : Symbol {
+      [StorableConstructor]
+      private TextSymbol(StorableConstructorFlag _) : base(_) { }
+      private TextSymbol(Symbol original, Cloner cloner) : base(original, cloner) { }
+      public TextSymbol(string name) : base(name, "") {
+        Name = name;
+      }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new TextSymbol(this, cloner);
+      }
+      public override int MinimumArity {
+        get { return 0; }
+      }
+      public override int MaximumArity {
+        get { return int.MaxValue; }
+      }
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeParameters.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeParameters.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeParameters.cs	(revision 16892)
@@ -0,0 +1,97 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("A6293516-C146-469D-B248-31B866A1D94F")]
+  public sealed class RegressionTreeParameters : Item {
+    private readonly ISplitter splitter;
+    private readonly IPruning pruning;
+    private readonly ILeafModel leafModel;
+    private readonly int minLeafSize;
+    private readonly IRegressionProblemData problemData;
+    private readonly IRandom random;
+    public ISplitter Splitter {
+      get { return splitter; }
+    }
+    public IPruning Pruning {
+      get { return pruning; }
+    }
+    public ILeafModel LeafModel {
+      get { return leafModel; }
+    }
+    public int MinLeafSize {
+      get { return minLeafSize; }
+    }
+    private IRegressionProblemData ProblemData {
+      get { return problemData; }
+    }
+    public IRandom Random {
+      get { return random; }
+    }
+    public IEnumerable<string> AllowedInputVariables {
+      get { return ProblemData.AllowedInputVariables; }
+    }
+    public string TargetVariable {
+      get { return ProblemData.TargetVariable; }
+    }
+    public IDataset Data {
+      get { return ProblemData.Dataset; }
+    }
+
+    #region Constructors & Cloning
+    [StorableConstructor]
+    private RegressionTreeParameters(StorableConstructorFlag _) : base(_) { }
+    private RegressionTreeParameters(RegressionTreeParameters original, Cloner cloner) : base(original, cloner) {
+      problemData = cloner.Clone(original.problemData);
+      random = cloner.Clone(original.random);
+      leafModel = cloner.Clone(original.leafModel);
+      splitter = cloner.Clone(original.splitter);
+      pruning = cloner.Clone(original.pruning);
+      minLeafSize = original.minLeafSize;
+    }
+
+    public RegressionTreeParameters(IPruning pruning, int minleafSize, ILeafModel leafModel,
+      IRegressionProblemData problemData, IRandom random, ISplitter splitter) {
+      this.problemData = problemData;
+      this.random = random;
+      this.leafModel = leafModel;
+      this.splitter = splitter;
+      this.pruning = pruning;
+      minLeafSize = Math.Max(pruning.MinLeafSize(problemData, leafModel), Math.Max(minleafSize, leafModel.MinLeafSize(problemData)));
+    }
+    public RegressionTreeParameters(ILeafModel modeltype, IRegressionProblemData problemData, IRandom random) {
+      this.problemData = problemData;
+      this.random = random;
+      leafModel = modeltype;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RegressionTreeParameters(this, cloner);
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeUtilities.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeUtilities.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/M5Utilities/RegressionTreeUtilities.cs	(revision 16892)
@@ -0,0 +1,61 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  internal static class RegressionTreeUtilities {
+    public static ResultCollection RunSubAlgorithm(IAlgorithm alg, int random, CancellationToken cancellationToken) {
+      if (alg.Parameters.ContainsKey("SetSeedRandomly") && alg.Parameters.ContainsKey("Seed")) {
+        var seed = alg.Parameters["Seed"].ActualValue as IntValue;
+        var setSeed = alg.Parameters["SetSeedRandomly"].ActualValue as BoolValue;
+        if (seed == null || setSeed == null)
+          throw new ArgumentException("The parameters SetSeedRandomly and Seed do not have the expected type");
+        setSeed.Value = false;
+        seed.Value = random;
+      }
+      if (alg.ExecutionState != ExecutionState.Paused) alg.Prepare();
+      alg.Start(cancellationToken);
+      var res = alg.Results;
+      alg.Runs.Clear();
+      return res;
+    }
+
+    public static void SplitRows(IReadOnlyList<int> rows, IDataset data, string splitAttr, double splitValue, out IReadOnlyList<int> leftRows, out IReadOnlyList<int> rightRows) {
+      //TODO check and revert?: points at borders are now used multipe times
+      var assignment = data.GetDoubleValues(splitAttr, rows).Select(x => x.IsAlmost(splitValue) ? 2 : x < splitValue ? 0 : 1).ToArray();
+      leftRows = rows.Zip(assignment, (i, b) => new {i, b}).Where(x => x.b == 0 || x.b == 2).Select(x => x.i).ToList();
+      rightRows = rows.Zip(assignment, (i, b) => new {i, b}).Where(x => x.b > 0).Select(x => x.i).ToList();
+    }
+
+    public static IDataset ReduceDataset(IDataset data, IReadOnlyList<int> rows, IReadOnlyList<string> inputVariables, string target) {
+      return new Dataset(inputVariables.Concat(new[] {target}), inputVariables.Concat(new[] {target}).Select(x => data.GetDoubleValues(x, rows).ToList()));
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionNodeModel.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionNodeModel.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/MetaModels/RegressionNodeModel.cs	(revision 16892)
@@ -0,0 +1,175 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;                                                  
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("C20C7DF1-CE33-4CCD-88D3-E145CFE239AC")]
+  public class RegressionNodeModel : RegressionModel {
+    #region Properties
+    public double PruningStrength = double.NaN;
+    private IReadOnlyList<string> Variables {
+      get {
+        if (IsLeaf && Model == null) return new List<string>();
+        if (IsLeaf) return Model.VariablesUsedForPrediction.ToList();
+        var set = new HashSet<string> {SplitAttribute};
+        var vl = Left.Variables;
+        var vr = Right.Variables;
+        for (var i = 0; i < vl.Count; i++) set.Add(vl[i]);
+        for (var i = 0; i < vr.Count; i++) set.Add(vr[i]);
+        return set.ToList();
+      }
+    }
+    [Storable]
+    internal int NumSamples { get; private set; }
+    [Storable]
+    internal bool IsLeaf { get; private set; }
+    [Storable]
+    private IRegressionModel Model { get; set; }
+
+    [Storable]
+    public string SplitAttribute { get; private set; }
+    [Storable]
+    public double SplitValue { get; private set; }
+    [Storable]
+    public RegressionNodeModel Left { get; private set; }
+    [Storable]
+    public RegressionNodeModel Right { get; private set; }
+    [Storable]
+    public RegressionNodeModel Parent { get; private set; }
+    #endregion
+
+    #region HLConstructors
+    [StorableConstructor]
+    protected RegressionNodeModel(StorableConstructorFlag _) : base(_) { }
+    protected RegressionNodeModel(RegressionNodeModel original, Cloner cloner) : base(original, cloner) {
+      IsLeaf = original.IsLeaf;
+      Model = cloner.Clone(original.Model);
+      SplitValue = original.SplitValue;
+      SplitAttribute = original.SplitAttribute;
+      Left = cloner.Clone(original.Left);
+      Right = cloner.Clone(original.Right);
+      Parent = cloner.Clone(original.Parent);
+      NumSamples = original.NumSamples;
+    }
+    private RegressionNodeModel(string targetAttr) : base(targetAttr) {
+      IsLeaf = true;
+    }
+    private RegressionNodeModel(RegressionNodeModel parent) : this(parent.TargetVariable) {
+      Parent = parent;
+      IsLeaf = true;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RegressionNodeModel(this, cloner);
+    }
+    public static RegressionNodeModel CreateNode(string targetAttr, RegressionTreeParameters regressionTreeParams) {
+      return regressionTreeParams.LeafModel.ProvidesConfidence ? new ConfidenceRegressionNodeModel(targetAttr) : new RegressionNodeModel(targetAttr);
+    }
+    private static RegressionNodeModel CreateNode(RegressionNodeModel parent, RegressionTreeParameters regressionTreeParams) {
+      return regressionTreeParams.LeafModel.ProvidesConfidence ? new ConfidenceRegressionNodeModel(parent) : new RegressionNodeModel(parent);
+    }
+    #endregion
+
+    #region RegressionModel
+    public override IEnumerable<string> VariablesUsedForPrediction {
+      get { return Variables; }
+    }
+    public override IEnumerable<double> GetEstimatedValues(IDataset dataset, IEnumerable<int> rows) {
+      if (!IsLeaf) return rows.Select(row => GetEstimatedValue(dataset, row));
+      if (Model == null) throw new NotSupportedException("The model has not been built correctly");
+      return Model.GetEstimatedValues(dataset, rows);
+    }
+    public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+      return new RegressionSolution(this, problemData);
+    }
+    #endregion
+
+    internal void Split(RegressionTreeParameters regressionTreeParams, string splitAttribute, double splitValue, int numSamples) {
+      NumSamples = numSamples;
+      SplitAttribute = splitAttribute;
+      SplitValue = splitValue;
+      Left = CreateNode(this, regressionTreeParams);
+      Right = CreateNode(this, regressionTreeParams);
+      IsLeaf = false;
+    }
+
+    internal void ToLeaf() {
+      IsLeaf = true;
+      Right = null;
+      Left = null;
+    }
+
+    internal void SetLeafModel(IRegressionModel model) {
+      Model = model;
+    }
+
+    internal IEnumerable<RegressionNodeModel> EnumerateNodes() {
+      var queue = new Queue<RegressionNodeModel>();
+      queue.Enqueue(this);
+      while (queue.Count != 0) {
+        var cur = queue.Dequeue();
+        yield return cur;
+        if (cur.Left == null && cur.Right == null) continue;
+        if (cur.Left != null) queue.Enqueue(cur.Left);
+        if (cur.Right != null) queue.Enqueue(cur.Right);
+      }
+    }
+
+    #region Helpers
+    private double GetEstimatedValue(IDataset dataset, int row) {
+      if (!IsLeaf) return (dataset.GetDoubleValue(SplitAttribute, row) <= SplitValue ? Left : Right).GetEstimatedValue(dataset, row);
+      if (Model == null) throw new NotSupportedException("The model has not been built correctly");
+      return Model.GetEstimatedValues(dataset, new[] {row}).First();
+    }
+    #endregion
+
+    [StorableType("1FF9E216-6AF1-4282-A7EF-3FA0C1DB29C8")]
+    private sealed class ConfidenceRegressionNodeModel : RegressionNodeModel, IConfidenceRegressionModel {
+      #region HLConstructors
+      [StorableConstructor]
+      private ConfidenceRegressionNodeModel(StorableConstructorFlag _) : base(_) { }
+      private ConfidenceRegressionNodeModel(ConfidenceRegressionNodeModel original, Cloner cloner) : base(original, cloner) { }
+      public ConfidenceRegressionNodeModel(string targetAttr) : base(targetAttr) { }
+      public ConfidenceRegressionNodeModel(RegressionNodeModel parent) : base(parent) { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new ConfidenceRegressionNodeModel(this, cloner);
+      }
+      #endregion
+
+      public IEnumerable<double> GetEstimatedVariances(IDataset dataset, IEnumerable<int> rows) {
+        return IsLeaf ? ((IConfidenceRegressionModel)Model).GetEstimatedVariances(dataset, rows) : rows.Select(row => GetEstimatedVariance(dataset, row));
+      }
+
+      private double GetEstimatedVariance(IDataset dataset, int row) {
+        return !IsLeaf ? ((IConfidenceRegressionModel)(dataset.GetDoubleValue(SplitAttribute, row) <= SplitValue ? Left : Right)).GetEstimatedVariances(dataset, row.ToEnumerable()).Single() : ((IConfidenceRegressionModel)Model).GetEstimatedVariances(dataset, new[] {row}).First();
+      }
+
+      public override IRegressionSolution CreateRegressionSolution(IRegressionProblemData problemData) {
+        return new ConfidenceRegressionSolution(this, problemData);
+      }
+    }
+  }
+}
